-- general OpenGL function for GEM

require('opengl')

local M = pd.Class:new():register("gl")

function M:initialize(name,atoms)
	local glname = atoms[1]
	if not glname then 
		return false 
	end
	
	self.glfun = gl[glname]
	if self.glfun then
		self.args = {}
		for i,a in ipairs(atoms) do
			if i > 1 then 
				self.args[i-1] = a 
			end
	    end
		self.inlets = (#self.args)+1
		self.outlets = 1
	    return true
	else
		return false
	end
end

function M:in_1_gem_state(atoms)
	self.glfun(unpack(self.args))
	self:outlet(1,"gem_state",atoms)
end

function M:in_1_list(atoms)
	self.args = atoms
end

function M:in_n_float(inlet,atom) 
	if inlet > 1 then
		self.args[inlet-1] = atom
	end
end

function M:in_n_symbol(inlet,atom) 
	if inlet > 1 then
		self.args[inlet-1] = atom
	end
end
